#include <stdio.h>
#include <stdlib.h>
#include <X11/IntrinsicP.h>
#include <X11/StringDefs.h>
#include "TourneyfieldP.h"

static XtResource resources[]={
#define offset(field) XtOffsetOf(TourneyfieldRec, tourneyfield.field)
	/* {name, class, type, size, offset, default_type, default_addr} */
	/*{ XtNtourneyfieldResource, XtCTourneyfieldResource, XtRTourneyfieldResource, 
		sizeof(char*), offset(resource), XtRString, (XtPointer)"default"},*/
	{ XtNinputCallback, XtCCallback, XtRCallback, 
		sizeof(XtCallbackList), offset(input_callback), XtRCallback, NULL},
	{ XtNresizeCallback, XtCCallback, XtRCallback, 
		sizeof(XtCallbackList), offset(resize_callback), XtRCallback, NULL},
	{ XtNexposeCallback, XtCCallback, XtRCallback, 
		sizeof(XtCallbackList), offset(expose_callback), XtRCallback, NULL},
#undef offset
};

static void inputAction(Widget, XEvent*, String*, Cardinal*);
static void quitAction(Widget, XEvent*, String*, Cardinal*);
//only input, and quit are handled through actions
// Expose is also an event and could be called as an action routine
// but i don't
static void resizeAction(Widget);
static void exposeAction(Widget, XEvent*, Region region);
//static Boolean focusDing(Widget, Time*);

static XtActionsRec actions[]={ /* what function is called when an action occurs */
	/* {name, procedure}, */
	{"input", inputAction},
	{"Quit", quitAction},
};

static char translations[]=  /* translate events to actions */
"	<KeyRelease>:    input()\n <BtnUp>:         input()\n <KeyPress>:      input()\n <BtnDown>:       input() ";

#define Superclass      (&widgetClassRec)
TourneyfieldClassRec tourneyfieldClassRec = {
  /* core */
  {
    (WidgetClass)Superclass,            /* superclass */
    "Tourneyfield",                     /* class_name */
    sizeof(TourneyfieldRec),            /* widget_size */
    NULL,                               /* class_initialize */
    NULL,                               /* class_part_initialize */
    False,                              /* class_inited */
    /*TourneyfieldInitialize,             /* initialize */
		NULL,
    NULL,                               /* initialize_hook */
    XtInheritRealize,                   /* realize */
    actions,                            /* actions */
    XtNumber(actions),                  /* num_actions */
    resources,                          /* resources */
    XtNumber(resources),                /* num_resources */
    NULLQUARK,                          /* xrm_class */
    True,                               /* compress_motion */
    True,                               /* compress_exposure */
    True,                               /* compress_enterleave */
    False,                              /* visible_interest */
    NULL,                               /* destroy */
    resizeAction,                       /* resize */
    exposeAction,                       /* expose */
    NULL,                               /* set_values */
    NULL,                               /* set_values_hook */
    XtInheritSetValuesAlmost,           /* set_values_almost */
    NULL,                               /* get_values_hook */
    /*XawAcceptFocus,                     /* accept_focus */
		/*XtInheritAcceptFocus,*/
		/*focusDing,*/
		NULL,
    XtVersion,                          /* version */
    NULL,                               /* callback_private */
    translations,                       /* tm_table */
    XtInheritQueryGeometry,             /* query_geometry */
    XtInheritDisplayAccelerator,        /* display_accelerator */
    NULL,                               /* extension */
  },
  /* tourneyfield */
  {
    0,                                  /* tourneyfield fields */
  }
};

WidgetClass tourneyfieldWidgetClass = (WidgetClass)&tourneyfieldClassRec;

/*static void
TourneyfieldInitialize(Widget request, Widget w, ArgList args, Cardinal *num_args) {
    TourneyfieldWidget tw = (TourneyfieldWidget)w;
    tw->tourneyfield.private = NULL;
}*/

static Bool TourneyfieldFunction(TourneyfieldWidget tw, int x, int y, Bool force) {
	return (force);
}

//static void myFocusIn(Widget w, XEvent *event, String *params, Cardinal *num_params) {
	//printf("focusIn\n");
//}
//static Boolean focusDing(Widget w, Time* t){
	//printf("focusDing\n");
	//Boolean answer(True);
	//return answer;
//}
static void inputAction(Widget w, XEvent *event, String *params, Cardinal *num_params) {
	//printf("inputAction\n");
	XtCallCallbacks(w, XtNinputCallback, (XtPointer)event);
}
static void quitAction(Widget w, XEvent *event, String *params, Cardinal *num_params) {
	printf("quitAction of tourneyfield\n");
	exit(0);
}
static void resizeAction(Widget w) {
	//printf("resizeAction\n");
	XtCallCallbacks(w, XtNresizeCallback, (XtPointer)NULL);
}

static void exposeAction(Widget w, XEvent *event, Region region) {
	//call the functions in the XtNexposeCallback callback list.
	//these functions have been registered with XtAddCallback
	//printf("exposeAction\n");
	XtCallCallbacks(w, XtNexposeCallback, (XtPointer)region);
}


