#include <stdio.h>
#include <stdlib.h>
#include <time.h> //randomize
//#include <unistd.h> //sleep, fork
//#include <sys/types.h> //fork
#include "nmhttp.h" //for hiScore list via http
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/keysym.h>
#include <X11/Xmu/Atoms.h> // for setting input focus
#include <X11/Xaw/AsciiText.h> //widget
#include <X11/Xaw/Label.h> //widget
#include <X11/Xaw/Command.h> //widget
#include <X11/xpm.h> //x pixmap
#include "Tourneyfield.h" /* my own widget */
//#include "nmmusic.h" //guess what for

#include "empty.xpm"
#include "beast.xpm"
#include "wall.xpm"
#include "grass.xpm"
#include "food.xpm"
#include "worm.xpm"

#define DEBUG 0 
#define Pempty 0
#define Pbeast 1
#define Pwall 2
#define Pfood 3
#define Pgrass 4
#define DELAY 100 //ms
#define INIFOOD 100 // one on how many square has a food at the beginning?

Pixmap beastPixmap, foodPixmap, wallPixmap, grassPixmap, emptyPixmap, wormPixmap;
XtAppContext appContext;
Display* display;
Screen* screen;
Window window;
GC myGC;
Widget toplevel, field, hiScore;
short int p[100][100];
XtIntervalId klok=0;
Dimension ww,hh;
int direction=1, futureDirection=0, ffutureDirection=0; //up, non, non
short int beastx[100], beasty[100]; //coor of 0=head, 1=neck
int nbeast, noInput=0;
int score, nx, ny, dontExpose=0; // dont expose if i want to resize again
Atom wm_delete_window;

void quit(){
	printf("Have a nice X session.\n");
	XtDestroyWidget(toplevel);
	XtDestroyApplicationContext(appContext);
	exit(0);
}
static void stop(const char* message){
	fprintf(stderr, "%s\n", message);
	exit(1);
}
void quitAction(Widget w, XEvent *event, String *params, Cardinal *num_params){
	quit();
}

void newgameAction(Widget w, XEvent *event, String *params, Cardinal *num_params);

XtActionsRec wurm_actions[] = {
	"Quit",     quitAction,
	"Newgame",  newgameAction
};

void putFood(int noDisplay=0){
	int x,y;
	do{
		x=rand()%(nx-2)+1; //assume RAND_MAX >> nx
		y=rand()%(ny-2)+1;
	}while (p[x][y]!=Pempty);
	p[x][y]=Pfood;
	if(!noDisplay)XCopyArea(display, foodPixmap, window, myGC, 0, 0, 16, 16, x*16, y*16);
}
void putGrass(){
	int x,y,i=0;
	/* x=rand()%(nx-2)+1;
	y=rand()%(ny-2)+1;
	if(rand()%2){//vertical
		for(i=0;i<10;i++){
			y++;
			if((y<(ny-1)) && (p[x][y]==Pwall)){
				p[x][y]=Pgrass;
				XCopyArea(display, grassPixmap, window, myGC, 0, 0, 16, 16, x*16, y*16);
			}
		}
	} else {
		for(i=0;i<10;i++){
			x++;
			if((x<(nx-1)) && (p[x][y]==Pwall)){
				p[x][y]=Pgrass;
				XCopyArea(display, grassPixmap, window, myGC, 0, 0, 16, 16, x*16, y*16);
			}
		}
	}
	*/
	for(i=0; i<2; i++){
		if(i++>nx*ny)return;
		x=rand()%(nx-2)+1;
		y=rand()%(ny-2)+1;
		if(p[x][y]==Pwall){
			p[x][y]=Pgrass;
			XCopyArea(display, grassPixmap, window, myGC, 0, 0, 16, 16, x*16, y*16);
		}
	}
}
void writeScore(){
	char scoreString[5];
	//XClearArea(display, window, 5, 1, 43, 14, False); //no exposures
	sprintf(scoreString, "%4d", score);
	XDrawImageString(display, window, myGC, 16, 12, scoreString, 4);
	
}
void initGame(){ //stop the game and (re)init vars
	int x,y;
	if(DEBUG)printf("initgame: nx:%d ny:%d\n",nx,ny);
	direction=1, futureDirection=0, ffutureDirection=0;
	score=0;
	for(x=0;x<100;x++)
		for(y=0;y<100;y++)
			if((x==0)||(y==0)||(x==nx-1)||(y==ny-1))p[x][y]=Pwall;
			else p[x][y]=Pempty;
	p[nx/2][ny-2]=Pbeast;
	p[nx/2][ny-3]=Pbeast;
	p[nx/2][ny-4]=Pbeast;
	p[nx/2][ny-5]=Pbeast;
	p[nx/2][ny-6]=Pbeast;
	nbeast=5;
	beastx[4]=nx/2; beasty[4]=ny-2;
	beastx[3]=nx/2; beasty[3]=ny-3;
	beastx[2]=nx/2; beasty[2]=ny-4;
	beastx[1]=nx/2; beasty[1]=ny-5;
	beastx[0]=nx/2; beasty[0]=ny-6;
	for(x=0;x<(nx*ny/INIFOOD);x++)putFood(1); //1 means don't display
	if(klok){
		XtRemoveTimeOut(klok);
		klok=0;
	}
}
void endGame(){
	noInput=1; //don't let the field respond to keys
	if(DEBUG)printf("Your score was: %d\n", score);
	XtVaSetValues (hiScore, 
		XtNlabel, "retreiving High Scores...",
		NULL);
	char requestString[256];
	sprintf(requestString, "www-marie.sci.kun.nl/cgi-bin/nmwurm?nx=%d&ny=%d&user=%s&score=%d", 
		nx, ny, getenv("USER"), score); 
	initGame();
	XtUnmanageChild(field);
	XtManageChild(hiScore);

	//int i=fork();
	//if((i==-1)||(i==0)){ //failure, this tread is the only one and the user will have to wait
		// or i am the child and will ask the high scores
		char* string=nmhttp(requestString);
		XtVaSetValues (hiScore, 
			XtNlabel, string,
			NULL); //this does nothing if hiScore has already been destroyed
			// this not a coincedence but a real documented feature of X
		free(string);
		//if(i==0)exit(0); //stop if child 
	//}
}
void newgameAction(Widget w, XEvent *event, String *params, Cardinal *num_params){
	// this action is called for all <Key> events in the hiScore widget
	// the tourneyfield widget class handles it's own <Key> events
	XKeyEvent key;
	int keySym;
	if(event->type==KeyPress){
		key=event->xkey;
		keySym=XLookupKeysym(&key, 0);
		switch(keySym){
			case XK_Left:
			case XK_Right:
			case XK_Down:
			case XK_Up:
				break;
			case XK_Escape:
				quit();
			default:
				if(DEBUG)printf("wurm newgameAction\n");
				XtUnmanageChild(hiScore);
				XtManageChild(field);
				noInput=0;
		}
	}
	return;
}

void timerCB(XtPointer client_data, XtIntervalId* id){
	int i;
	int oldLastx, oldLasty;
	if(futureDirection){
		if (((futureDirection+2)%4)!=(direction%4)){
			//if there is a futuredirection and it is not straight back
			direction=futureDirection;
		}
		futureDirection=ffutureDirection;
		ffutureDirection=0;
	}
	p[beastx[nbeast-1]][beasty[nbeast-1]]=Pempty;
	XCopyArea(display, emptyPixmap, window, myGC, 0, 0, 16, 16, beastx[nbeast-1]*16, beasty[nbeast-1]*16);
	oldLastx=beastx[nbeast-1]; oldLasty=beasty[nbeast-1];
	for (i=nbeast-1; i>0; i--){
		beastx[i]=beastx[i-1]; beasty[i]=beasty[i-1];
	}
	/*	 1
			4 2
			 3 */
	switch(direction){
		case 1 :
			beasty[0]--;
			break;
		case 2 :
			beastx[0]++;
			break;
		case 3 :
			beasty[0]++;
			break;
		case 4 :
			beastx[0]--;
			break;
	}
	switch(p[beastx[0]][beasty[0]]){
	case Pfood:
		score++;
	case Pgrass:
		if(p[beastx[0]][beasty[0]]==Pgrass){
			score+=5;
		}
		putFood();
		putGrass(); //there is a chance of 2*wall/area that grass appears
		writeScore();
		beastx[nbeast]=oldLastx; beasty[nbeast]=oldLasty; nbeast++;
		if(nbeast==31){
			for(i=5;i<nbeast;i++){
				p[beastx[i]][beasty[i]]=Pwall;
				XCopyArea(display, wallPixmap, window, myGC, 0, 0, 16, 16, beastx[i]*16, beasty[i]*16);
			}
			nbeast=5;
		}
		break;
	case Pwall:
	case Pbeast:
		endGame();
		return;
	}
	p[beastx[0]][beasty[0]]=Pbeast;
	XCopyArea(display, beastPixmap, window, myGC, 0, 0, 16, 16, beastx[0]*16, beasty[0]*16);
	klok=XtAppAddTimeOut(appContext, DELAY, timerCB, NULL); //ms, functie, client_data
}
void inputCB(Widget w, XtPointer client_data, XtPointer call_data){
	if(noInput)return;
	XEvent* event=(XEvent*) call_data;
	XKeyEvent key;
	int keySym;
	switch(event->type){
		//case ButtonPress :
			//printf("Jippie, een button press event\n");
			//break;
		case KeyPress :
			if(!klok){//als de wetten der fysica nog niet gelden
				klok=XtAppAddTimeOut(appContext, DELAY, timerCB, NULL); //ms, functie, client_data
			}
			key=event->xkey;
			keySym=XLookupKeysym(&key, 0);
			switch(keySym){
				case XK_Left :
					if(futureDirection)ffutureDirection=4;
					else futureDirection=4;
					break;
				case XK_Down :
					if(futureDirection)ffutureDirection=3;
					else futureDirection=3;
					break;
				case XK_Right :
					if(futureDirection)ffutureDirection=2;
					else futureDirection=2;
					break;
				case XK_Up :
					if(futureDirection)ffutureDirection=1;
					else futureDirection=1;
					break;
				case XK_Escape :
					quit();
				case XK_p :
					if(klok){
						XtRemoveTimeOut(klok);
						klok=0;
					}
					if(DEBUG)printf("De tijd staat even stil.\n");
					break;
				default :
					if(DEBUG)printf("Don\'t push me!\n");
					break;
			}
			break;
		//case KeyRelease :
			//break;
		default :
			break;
	}
}
void resizeCB(Widget w, XtPointer client_data, XtPointer call_data){
	int xOver, yOver;
	static int reresize=0;
	XtVaGetValues(field, XtNwidth, &ww, XtNheight, &hh, NULL);
	if(DEBUG)printf("resize: wi:%d h:%d\n", ww, hh);
	nx=ww/16; xOver=ww%16;
	ny=hh/16; yOver=hh%16;
	if((xOver || yOver)&& !reresize){
		if(DEBUG)printf("we gaan nogmaals resizen want xover: %d yover: %d\n",xOver, yOver);
		reresize=1;
		XtVaGetValues(toplevel, XtNwidth, &ww, XtNheight, &hh, NULL);
		if(DEBUG)printf("toplevel width: %d, hieght: %d\n", ww,hh);
		dontExpose=1;
		XtVaSetValues(toplevel,
			XtNwidth, ww-xOver,
			XtNheight, hh-yOver,
			NULL);
		return;
	}
	dontExpose=0; reresize=0;
	initGame(); //stops the game and reinits vars
}
void exposeCB(Widget w, XtPointer client_data, XtPointer call_data){
	int x,y;
	if(dontExpose)return;
	static int firstTime=1;
	if(firstTime){
		//nmmusic(display, appContext, "elise");
		XtOverrideTranslations(hiScore, XtParseTranslationTable("<Key>: Newgame()") );
		XtOverrideTranslations(toplevel, XtParseTranslationTable("<Message>WM_PROTOCOLS:Quit()") );
			// quit is an action not a function
		wm_delete_window = XInternAtom(XtDisplay(toplevel), "WM_DELETE_WINDOW", False); 
		//call quit when WM asks
		XSetWMProtocols (XtDisplay(toplevel), XtWindow(toplevel), &wm_delete_window, 1);
	
		XSizeHints sizeHints;
		sizeHints.min_width=160; sizeHints.min_height=160;
			sizeHints.width_inc=16; sizeHints.height_inc=16;
			sizeHints.flags=(PMinSize | PResizeInc);
		XSetWMNormalHints(XtDisplay(toplevel), XtWindow(toplevel), &sizeHints);
		firstTime=0;
	}
	if(DEBUG)printf("expose\n");
	writeScore();
	for(y=0;y<ny;y++){
		for(x=0;x<nx;x++){
			//printf("x: %d, y: %d, pxy: %d\n", x, y, p[x][y]);
			switch(p[x][y]){
				case Pempty :
					XCopyArea(display, emptyPixmap, window, myGC, 0, 0, 16, 16, x*16, y*16);
					break;
				case Pbeast :
					XCopyArea(display, beastPixmap, window, myGC, 0, 0, 16, 16, x*16, y*16);
					break;
				case Pwall :
					XCopyArea(display, wallPixmap, window, myGC, 0, 0, 16, 16, x*16, y*16);
					break;
				case Pgrass :
					XCopyArea(display, grassPixmap, window, myGC, 0, 0, 16, 16, x*16, y*16);
					break;
				case Pfood :
					XCopyArea(display, foodPixmap, window, myGC, 0, 0, 16, 16, x*16, y*16);
					break;
			}
		}
	}
}

int main(int argc, char **argv) {
	time_t t;
	time(&t);
	srand((unsigned int) t);
	String fallbacks[] = { "*background: grey", "*input: True",
		NULL };
	toplevel = XtVaAppInitialize(&appContext, "Nmwurm", NULL, 0, &argc, argv, fallbacks, 
		XtNwidth, 608, XtNheight, 480, 
		NULL);
	XtAppAddActions(appContext, wurm_actions, XtNumber(wurm_actions));
	display = XtDisplay(toplevel);
	screen = XtScreen(toplevel);
	window = RootWindowOfScreen(screen); //the real window is not known until realisation
		//be careful only to use window to determine screen, window doesn't exist yet
		//width and height of all images is 24

	//XpmReadFileToPixmap(display, window, "empty.xpm", &emptyPixmap, NULL, NULL);
	//XpmReadFileToPixmap(display, window, "beast.xpm", &beastPixmap, NULL, NULL);
	//XpmReadFileToPixmap(display, window, "wall.xpm", &wallPixmap, NULL, NULL);
	//XpmReadFileToPixmap(display, window, "grass.xpm", &grassPixmap, NULL, NULL);
	//XpmReadFileToPixmap(display, window, "food.xpm", &foodPixmap, NULL, NULL);
	XpmCreatePixmapFromData(display, window, empty_xpm, &emptyPixmap, NULL, NULL);
	XpmCreatePixmapFromData(display, window, beast_xpm, &beastPixmap, NULL, NULL);
	XpmCreatePixmapFromData(display, window, wall_xpm, &wallPixmap, NULL, NULL);
	XpmCreatePixmapFromData(display, window, grass_xpm, &grassPixmap, NULL, NULL);
	XpmCreatePixmapFromData(display, window, food_xpm, &foodPixmap, NULL, NULL);
	XpmCreatePixmapFromData(display, window, worm, &wormPixmap, NULL, NULL);
	
	XGCValues gcv;
	XFontStruct* fontInfo;
	fontInfo = XLoadQueryFont(display, "9x15");
	if(!fontInfo)fontInfo=XLoadQueryFont(display, "fixed");
	if(!fontInfo)stop("Get yourself some decent font server");
	gcv.foreground = BlackPixelOfScreen(screen);
	gcv.background = WhitePixelOfScreen(screen);
	gcv.font = fontInfo->fid;
	myGC = XCreateGC (display, RootWindowOfScreen(screen), 
		GCForeground | GCBackground | GCFont, &gcv);
	
	field = XtVaCreateManagedWidget("field", tourneyfieldWidgetClass, toplevel,
		NULL);
	hiScore = XtVaCreateWidget("hiScore", labelWidgetClass, toplevel, //watch the difference
		XtNlabel, "retreiving High Scores...",
		XtNbackgroundPixmap, wormPixmap,
		NULL);
	
	XtAddCallback(field, XtNexposeCallback, exposeCB, NULL); //input, expose, resize
	XtAddCallback(field, XtNresizeCallback, resizeCB, NULL);
	XtAddCallback(field, XtNinputCallback, inputCB, NULL);
	
	XtRealizeWidget(toplevel);
	window=XtWindow(field); 
	//do not draw in this before the first expose event, the window might not exist


	XtAppMainLoop(appContext);
}
